<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { init } from 'aos';
import {
  SlpContainer,
  CTA as CallToAction,
  TabsMenu,
  Copy,
  CopyMedia,
  SlpColumn,
  FreeTrialCTA,
} from '../../components/common/index';
import {
  CompanyCopyCard as CopyCard,
  DataCard,
  CopyMediaCard,
  Markdown,
  CompanyCards,
} from '../../components/company/index';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  name: 'Company',
  components: {
    SlpColumn,
    TabsMenu,
    SlpContainer,
    CallToAction,
    Copy,
    CopyMedia,
    CopyCard,
    DataCard,
    CopyMediaCard,
    FreeTrialCTA,
    Markdown,
    CompanyCards,
  },
  async asyncData({ $content, params, error }: any) {
    try {
      const company = await $content(
        `company/${params.company ? params.company : 'index'}`,
      ).fetch();

      return { company };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).company, this.$route.path);
  },
  mounted() {
    init({
      once: true,
    });
  },
});
</script>

<template>
  <SlpContainer class="container__company">
    <SlpColumn :cols="10">
      <component
        :is="component.name"
        v-for="component in company.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpColumn>
    <SlpRow>
      <SlpColumn>
        <FreeTrialCTA variant="image" type="pricing" />
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.container__company {
  display: flex;
  flex-direction: column;
  align-items: center;
}
</style>
